<template>
	<view>
		<view class="tab ddflex">
			<view :class="'li ' + (type == 1 ? 'active' : '')" @click="swiType(1)">我发布的</view>
			<view :class="'li ' + (type == 2 ? 'active' : '')" @click="swiType(2)">我收藏的</view>
			<!-- <view :class="'li ' + (type == 3 ? 'active' : '')" @click="swiType(3)">日记</view> -->
		</view>
		<view class="placeholder-view"></view>
		<view class="list" v-if="pageList && pageList.length > 0">
			<view class="li" v-for="(item, index) in pageList" :key="index">
				<view class="user ddflex" @click="toUserHomePage(item.userDTO.id)">
					<image :src="item.userDTO.avatar" mode="aspectFill" class="userimg"></image>
					<view class="fflex">
						<view class="namea ddflex">
							<view class="name fflex ddflex">
								{{ item.userDTO.nickName }}
								<image v-if="item.userDTO.levelGrade > 0" src="../../static/images/vip_tag.png" class="vip-tag"></image>
							</view>
							<view class="time">{{ item.time }}</view>
						</view>
						<view class="area" v-if="item.userDTO.cityName">{{ item.userDTO.provinceName }} {{ item.userDTO.cityName }}</view>
					</view>
				</view>
				<!-- 分享的动态 -->
				<block v-if="item.source">
					<view class="link ddflex" @click="jumpUrlDetail(item)">
						<block v-if="item.url && item.url.length > 0"><image mode="aspectFill" v-if="idx == 0" v-for="(it, idx) in item.url" :src="it" :key="idx"></image></block>
						<view class="fflex tover"><rich-text :nodes="item.content"></rich-text></view>
					</view>
				</block>
				<!-- 非分享的动态 -->
				<block v-else>
					<view v-if="item.type == 2" class="des tovers" @click="jumpUrlDetail(item)">
						<view class="wen">提问</view>
						{{ removeHtml(item.content) }}
					</view>
					<view class="des" v-else @click="jumpUrlDetail(item)"><rich-text :nodes="item.content"></rich-text></view>
					<!-- //如果有投票，就不显示图片 -->
					<block v-if="!item.qyPoll">
					<view class="video" v-if="item.isHaveVideo && config.open_community_video == 1">
						<video :src="item.url" :show-center-play-btn="false" :controls="item.isControls" :autoplay="item.isControls" :id="'myVideo'+index" @pause="videoPause(index)" @ended="videoEnded(index)"></video>
						<view class="video-play ddflex" @click="videoPlay(index)" v-if="item.isShowPlayBtn"><image src="../../static/images/play.png"></image></view>
					</view>
					<view class="imgbox ddflex" @click="jumpUrlDetail(item)" v-if="!item.isHaveVideo"><!-- @click="previewImgss(item.url, idx)" -->
						<block v-if="item.url&&item.url.length>0">
							<image mode="aspectFill" v-for="(it, idx) in item.url" :src="it" :key="idx"></image>
						</block>
					</view>
					</block>
					<!-- 话题 -->
					<view class="ddflex" v-if="item.qyDialogu">
						<view class="topic ddflex" @click="jumpUrl('/topics/detail/detail?topicId=' + item.qyDialogu.id)">
							<image src="../../static/images/topic.png"></image>
							{{ item.qyDialogu.title }}
						</view>
					</view>
					<view class="loca ddflex" @click="jumpUrlPoi(item,'/office/poi/index')" v-if="item.poiName"><image :src="picUrlss+'office_images/loca.png'"></image><text v-if="item.poiDistance > 0">{{item.poiDistance ? item.poiDistance < 1000 ? item.poiDistance+'m' : (item.poiDistance/1000).toFixed(1)+'km' : ''}}</text>{{item.poiName}}</view>
					<!-- 投票 -->
					<view :class="'vote-box' + (item.qyPoll && item.qyPoll.isEnd ? ' ends' : '')" v-if="item.qyPoll">
						<view class="vote-tit">{{ item.qyPoll.title }}</view>
						<block v-if="item.qyPoll.isVote == 1">
							<view class="vote-list end" @click="jumpUrlDetail(item)">
								<view :class="'lis ddflex  ' + (itpy.isVote == 1 ? 'active' : '')" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex">
									<view class="percent" :style="'width:' + parseFloat(itpy.proportion) + '%;'"></view>
									<view class="fflex">{{ itpy.name }}</view>
									<view>{{ parseFloat(itpy.proportion) + '%' }}</view>
								</view>
							</view>
						</block>
						<block v-else>
							<view class="vote-list">
								<view class="lis" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex" @click="submitPoll(item, index, idex)">
									{{ itpy.name }}
								</view>
							</view>
						</block>
						<view class="vote-can" v-if="item.qyPoll.isEnd">
							<text>{{ item.qyPoll.voteCount }}人参与</text>
							投票已结束
						</view>
					</view>
				</block>
				<view class="que ddflex" v-if="item.question" @click="jumpUrl('/learn/topic/index?questId=' + item.question.id)">
					<image src="../../static/images/ht_ico1.png" class="st-ico"></image>
					<view class="fflex"><rich-text :nodes="item.question.title" class="tovers"></rich-text></view>
					<image src="../../static/images/ht_ico2.png" class="st-rico"></image>
				</view>
				<view class="cates ddflex" v-if="item.question && item.question.cateName">
					<text>{{ item.question.cateName }}</text>
					<!-- <text>自动化测试</text> -->
				</view>
				<view class="opt ddflex" v-if="!item.source && type != 3">
					<view class="fflex" @click="jumpUrlDetail(item)">{{ item.count.browseCount }}次浏览</view>
					<view class="ddflex" @click="submitFabulous(2, item.id, index)">
						<image :src="'../../static/images/' + (item.isPraise == 1 ? 'like_h' : 'like') + '.png'"></image>
						{{ item.count.fabulousCount < 99 ? item.count.fabulousCount : '99+' }}
					</view>
					<view class="ddflex" @click="jumpUrlDetail(item)">
						<image src="../../static/images/comment.png"></image>
						{{ item.count.commentCount < 99 ? item.count.commentCount : '99+' }}
					</view>
					<!-- #ifdef MP-WEIXIN -->
					<button open-type="share" class="opt-share ddflex" :data-item="item">
						<image src="../../static/images/share.png"></image>
						分享
					</button>
					<!-- #endif -->
					<!-- #ifdef APP-PLUS -->
					<view class="opt-share ddflex" @click="appToShare(item)">
						<image src="../../static/images/share.png"></image>
						分享
					</view>
					<!-- #endif -->
				</view>
			</view>
		</view>
		<view class="nodata" v-else>
			<image :src="picUrlss + 'empty_jl.png'"></image>
			<text>{{ type == 1 ? '暂无动态' : type == 2 ? '暂无提问' : type == 3 ? '暂无日记' : '' }}</text>
		</view>
	</view>
</template>

<script>
const app = getApp();
const req = require('../../utils/request.js');
const api = require('../../utils/api.js');
const util = require('../../utils/util.js');
export default {
	data() {
		return {
			picUrlss: req.public.picUrls,
			userInfo: '',
			isLoad: true,
			form: {
				page: 1,
				limit: 10
			},
			type: 1, //1 聊一聊，2提问  3日记
			isExamine: 1,
			pageList: [],
			isShowView: false,
			videoCurrent: null,
			videoContext: '',
			config: {},
			currentPoi: {}
		};
	},

	onLoad() {
		this.userInfo = req.getStorage('userInfo');
		this.getOfficeList();
	},
	onShow() {
		this.config = JSON.parse(req.getStorage('configRes'))
	},

	onShareAppMessage(option) {
		let item = option.target.dataset.item; //取到传入的参数
		console.log('==', item);
		var url = '/office/detail/detail?contentId=' + item.id;
		var img = '';
		if (item.url) {
			var imgList = item.url;
			img = imgList[0];
		} else {
		}
		return {
			title: util.removeHtml(item.content),
			imageUrl: img,
			path: url
		};
	},

	onReachBottom() {
		this.form.page++;
		this.getOfficeList();
	},

	methods: {
		jumpUrl(url) {
			uni.navigateTo({
				url: url
			});
		},
		jumpUrlPoi(item,url){
			this.currentPoi = item;
			uni.navigateTo({
				url: url
			})
		},
		removeHtml(content) {
			return util.removeHtml(content);
		},

		//预览图片
		previewImgss(picUrls, index) {
			//预览合同图片
			var src = picUrls[index];
			let imgs = picUrls;
			uni.previewImage({
				current: src, // 当前显示图片的http链接
				urls: imgs
			});
		},

		jumpUrlDetail(item) {
			//日记，不做跳转
			if (this.type == 3) {
				return;
			}
			if (item.source) {
				this.jumpUrl('/office/detail/detail?contentId=' + item.source);
			} else {
				this.jumpUrl('/office/detail/detail?contentId=' + item.id);
			}
		},

		toUserHomePage(userId) {
			this.jumpUrl('/topics/home/home?userId=' + userId);
		},

		//切换类型
		swiType(type) {
			if (this.type == type) return false;
			this.type = type;
			this.isLoad = true;
			this.form.page = 1;
			this.isExamine = type;
			this.getOfficeList();
			if (this.videoCurrent != null) {
				var videoContextPrev = uni.createVideoContext('myVideo' + this.videoCurrent)
				videoContextPrev.stop()
				this.videoCurrent = ''
			}
			if (type == 1) {
				uni.setNavigationBarTitle({
					title: '我发布的'
				});
			} else {
				uni.setNavigationBarTitle({
					title: '我收藏的'
				});
			}
		},

		sum(arr) {
			var s = 0;
			for (var i = arr.length - 1; i >= 0; i--) {
				if (arr[i].count) {
					s += Number(arr[i].count);
				}
			}
			return s;
		},

		getOfficeList() {
			let that = this;
			var pramData = this.form;
			// pramData.type = this.type;
			pramData.orderType = 2;
			pramData.userId = this.userInfo.id;
			let apiUrl = '';
			if (this.type == 1) {
				apiUrl = '/api/v3/moments/list';
			} else {
				apiUrl = '/api/v3/moments/collectionList';
			}
			if (!this.isLoad) return false;
			this.isLoad = false;
			uni.showLoading();
			req.getRequest(apiUrl, pramData, data => {
				if (data && data.length > 0) {
					data.map(it => {
						if (it.qyPoll && it.qyPoll.isEnd) {
							it.qyPoll.voteCount = that.sum(JSON.parse(it.qyPoll.optionJson));
						}
						if(it.url){
							let h = it.url.substring(it.url.lastIndexOf('.') + 1)
							if(h.indexOf('mp4')<0&&h.indexOf('MP4')<0){
								it.url = it.url.split(',');
							}else{
								it.isHaveVideo = true
								it.isControls = false
								it.isShowPlayBtn = true
							}
						}
						it.content = '<div style="overflow: hidden;text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 5;-webkit-box-orient: vertical;word-break: break-all;">' + it.content + '</div>'
						return it;
					});
				}
				if (data && data.length >= this.form.limit) {
					this.isLoad = true;
				}
				if (this.form.page > 1) {
					data = this.pageList.concat(data);
				}
				this.pageList = data;
				this.isShowView = true;
				uni.hideLoading();
			});
		},

		//提交点赞、取消点赞；收藏、取消收藏
		submitFabulous(type, id, index) {
			if (!req.isLogins(true)) {
				return;
			}
			var dataP = {};
			dataP.type = type; //1，观看 ，2点赞，3评论，4分享，5收藏
			dataP.momentsId = id;
			req.postRequestLoding('/api/v3/fabulous/save', dataP, data => {
				if (type == 2) {
					//动态点赞
					if (this.pageList[index].isPraise == 1) {
						//已赞
						this.pageList[index].isPraise = 0;
						this.pageList[index].count.fabulousCount--;
					} else {
						this.pageList[index].isPraise = 1;
						this.pageList[index].count.fabulousCount++;
					}
				}
			});
		},

		//提交投票
		submitPoll(item, pIndex, pollIndex) {
			if (item.qyPoll.isEnd) {
				this.jumpUrlDetail(item);
				return false;
			}
			var dataP = {};
			// dataP.id = item.id;
			dataP.pollId = item.qyPoll.id;
			var pollObjList = JSON.parse(item.qyPoll.optionJson);
			dataP.pollOptionCode = pollObjList[pollIndex].code;
			req.postRequest('/api/v3/poll/saveDetails', dataP, data => {
				req.msg('投票成功');
				//图片完之后要将该投票的对象返回，便于做渲染%
				this.pageList[pIndex].qyPoll = data;
			});
		},

		appToShare(item) {
			var img = '';
			if (item.url) {
				var imgList = item.url;
				img = imgList[0] + '?x-oss-process=style/w375';
			} else {
				let config = JSON.parse(req.getStorage('configRes'));
				img = config.share_pic;
			}
			var text = util.removeHtml(item.content);
			uni.share({
				provider: 'weixin',
				scene: 'WXSceneSession',
				type: 5,
				imageUrl: img,
				title: text,
				summary: text,
				miniProgram: {
					id: req.public.miniProgramGh_id,
					path: 'office/detail/detail?contentId=' + item.id,
					type: 0,
					webUrl: 'http://www.lemonban.com'
				},
				success: ret => {
					console.log(ret);
				},
				fail: ret => {
					console.log(ret);
				}
			});
		},
		videoPlay(index){
		    var that = this;
		    var curIdx = index;
		    this.pageList[index].isControls = true
		    this.pageList[index].isShowPlayBtn = false
		    // 有播放时先将prev暂停，再播放当前点击的current
		    if (that.videoCurrent != null) {
				var videoContextPrev = uni.createVideoContext('myVideo' + that.videoCurrent)
				if (that.videoCurrent != curIdx) {
					this.pageList[that.videoCurrent].isControls = false
					this.pageList[that.videoCurrent].isShowPlayBtn = true
					
					videoContextPrev.stop()
				}
				that.videoCurrent = curIdx
				var videoContextCurrent = uni.createVideoContext('myVideo' + curIdx)
				videoContextCurrent.play()
		    } else {  
				// 没有播放时播放视频
				that.videoCurrent = curIdx
				var videoContext = uni.createVideoContext('myVideo' + curIdx) // 对应的视频id
				videoContext.play()
		    }
		},
		videoPause(index){
			this.pageList[index].isControls = false
			this.pageList[index].isShowPlayBtn = true
		},
		videoEnded(index){
			this.pageList[index].isControls = false
			this.pageList[index].isShowPlayBtn = true
		}
	}
};
</script>

<style>
@import './release.css';
</style>
